angular.module('beamng.apps')
.directive('vfcdebug', [function () {
  return {
    templateUrl: '/ui/modules/apps/vFCDebug/app.html',
    //template:
    //'<div style="height:100%; width:100%;" class="bngApp">' +
    //  `{{:: 'Engine RPM' | translate}}: {{ data.engineInfo[4].toFixed() }} <br>` +
    //  `{{:: 'Fan RPM' | translate}}: {{ data.electrics.vFCData.radiatorFanRPM.toFixed() }} <br>` +
    //  `{{:: 'Coolant' | translate}}: {{ CoolantTemp }} <br>` +
    //  `{{:: 'Fan RPM Smoothing' | translate}}: {{ data.electrics.vFCData.FanRPMSmooth }} <br>` +
    //  `{{:: 'Clutch Engaged' | translate}}: {{ data.electrics.vFCData.ClutchEngaged }}` +
    //'</div>',
    replace: true,
    restrict: 'EA',
    scope: true,
    controller: ['$log', '$scope', function ($log, $scope) {
      var streamsList = ['engineThermalData']
      StreamsManager.add(streamsList)
      $scope.$on('$destroy', function () {
        StreamsManager.remove(streamsList)
      })

    $scope.buttonOn = false
    $scope.buttonOff = true

      $scope.engage = function () {
          bngApi.activeObjectLua('extensions.vFCMgr.engage()')
          if ($scope.buttonOn == false && $scope.ClutchEngaged == false) {
            $scope.buttonOn = true
            $scope.buttonOff = false
          } else {
            $scope.buttonOn = false
            $scope.buttonOff = true
          }
      }


      $scope.$on('streamsUpdate', function (event, data) {
        $scope.$evalAsync(function () {
          if (data.electrics.vFCData && data.engineThermalData) {
            $scope.data = data

            $scope.ClutchEngaged = $scope.data.electrics.vFCData.ClutchEngaged

            $scope.CoolantTemp = UiUnits.buildString('temperature', data.engineThermalData.coolantTemperature, 0)
            $scope.CoolantTempWarn = data.engineThermalData.coolantTemperature > data.engineThermalData.thermostatTemperature && data.engineThermalData.coolantTemperature < 120 && data.engineThermalData.thermostatStatus == 1
            $scope.CoolantTempError = data.engineThermalData.coolantTemperature > 120

            $scope.FanAirSpeed = UiUnits.buildString('speed', data.electrics.vFCData.clutchFanAirSpeed, 0)

            if ($scope.data.electrics.vFCData.FanRPMSmooth !== true) {
                 $scope.FanRPMSmoothDir = ""
            } else {
              if ($scope.ClutchEngaged == true) {
                 $scope.FanRPMSmoothDir = "Up"
              } else {
                 $scope.FanRPMSmoothDir = "Down"
              }
            }

          } else {
            $scope.data = undefined
          }
        })
      })
    }]
  }
}]);